#if (!defined _QAPPh_)
#define _QAPPh_

#include <time.h>
#include "qutil.h"

//#include "qdnutil.h"
//#include "qufname.h"
//#include "qufsrch.h"

// Directory service data
typedef struct _QServiceParms
{
  int sizelimit;
  int timelimit;
  int bindtime;   // Time in secs for which to maintain an idle connection
  BOOLEAN optimize_search;  // Optimize search DSAs (only initial substrings)
} QServiceParms;

// Connection information beyond what is contained in LDAP *ldapctx
// in QappContext.
typedef struct _QBindParms
{
  int bindmsgid;	// Used at startup for asynchronous binds
  char *hostname;
  int portnum;
  char *username;
  char *password;
  BOOLEAN bound;
  BOOLEAN binding;
  time_t idlestart;	// Start of idle time
} QBindParms;

////////////////////////////////////////////////////////////
//
// Application context contains per-application
// connection, authentication and configuration
// information.
//
typedef struct _QAppContext
{
  LDAP *ldapctx;	// LDAP connection information
  LDAP *oldldapctx;	// Used only when re-binding

  // Service information
  QServiceParms service;
  
  // Authentication/connection information
  QBindParms bind;

  // List of application requests
  //

  // Configuration information 
  //struct _QUFNdata UFNcnf;	// UFN paths
  //struct _QUFSdata UFScnf;	// Form search paths
  //struct _QNAMEdata NAMEcnf;
} QAppContext;

// Functions for creating and destroying application contexts
PGhandle  Qnew_app_context(void);
void Qfree_app_context(QAppContext ctx);

#endif /* _QAPPh_ */


