// QReadRequest.h: interface for the QReadRequest class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QREADREQUEST_H__12278AE1_07B6_11D3_89E9_AE8EC9E67C1B__INCLUDED_)
#define AFX_QREADREQUEST_H__12278AE1_07B6_11D3_89E9_AE8EC9E67C1B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "QRequest.h"
#include "QEntry.h"

class AFX_EXT_CLASS QReadRequest : public QRequest  
{
public:
	QReadRequest
  ( QDSManager *manager_arg, QRequestID req_id_arg, QRequester *requester_arg,
    QDN &dn_arg, PtrList<QAttrT> at_list_arg );

	virtual ~QReadRequest();

public:
  BOOL Invoke( QError *& err );

public:
  // Process an LDAP response
  BOOL HandleLDAPMessage( LDAP *ld, LDAPMessage *msg, QError *&err );

public:
  // Check whether an LDAP operation was invoked by this request
  BOOL IsTaskOwner( LDAP *ld, int ldap_msg_id );

public:
  // Abort an incomplete request
  void Abort();

private:
  int ldap_msg_id;
  QDN dn;
};

#endif // !defined(AFX_QREADREQUEST_H__12278AE1_07B6_11D3_89E9_AE8EC9E67C1B__INCLUDED_)
