// QEntry.h: interface for the QEntry class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QENTRY_H__9C1A9F61_C7EE_11D2_89E9_80E4E2C5541B__INCLUDED_)
#define AFX_QENTRY_H__9C1A9F61_C7EE_11D2_89E9_80E4E2C5541B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "QDN.h"
#include "QAttr.h"
#include "ldap.h"

// Forward references
class Oidtable;
class QDSManager;

class AFX_EXT_CLASS QEntry  
{
public:
	QEntry( QEntry *pEntry );
	QEntry( QDN &dn, QAttr &oc_attr, PtrList<QAttr> &attr_list );
  QEntry( QDSManager *ds, long conn_id, LDAP *ld, LDAPMessage *srch_res_entry );
	virtual ~QEntry();

public:
  BOOL IsSet() { return is_set; } ;

public:
  QDN &DN() { return dn ; } ;
	QDSManager *DS() { return dn.DS() ; } ;
	Oidtable *Table() { return dn.Table() ; } ;
	long GetConnID() { return dn.GetConnID() ; } ;
  QAttr *ObjectClass() { return oc_attr ; } ;
	QAttr *QueryGetAttr( QAttrT *pAT );
  BOOL HasObjectClass( QAttr oc );
  
public:
  POSITION GetHeadPosition();
  QAttr *GetNextAttr( POSITION &pos );

private:
  BOOL is_set;
  QDN dn;
  QAttr *oc_attr;
  PtrList<QAttr> attr_list;
};

#endif // !defined(AFX_QENTRY_H__9C1A9F61_C7EE_11D2_89E9_80E4E2C5541B__INCLUDED_)
